#include "..\inc\mytypes.h"
#include "..\inc\ch559_keil.h"
#include <intrins.h>

#define LOW(x)  (*((uint8_t*)&(##x)+1))
#define HIGH(x) (*((uint8_t*)&(##x)+0))

uint8_t IAP_ProgWord(uint16_t Addr,uint16_t Data)
{
   ROM_ADDR = Addr;
   ROM_DATA = Data;
#ifndef TESTCODE
  if (ROM_STATUS & bROM_ADDR_OK)
   {
      if ((uint8_t) &IAP_ProgWord & 0x01)
      {
         ROM_CTRL = ROM_CMD_PROG;
         _nop_();
      }
      else
      {
         _nop_();
         ROM_CTRL = ROM_CMD_PROG;
      }
      return((ROM_STATUS ^ bROM_ADDR_OK) & 0x7F);
   }
   else return(bROM_ADDR_OK);
#else
   return 0;  
#endif   
}

uint8_t IAP_DeletePage(uint8_t page)
{
   ROM_ADDR_H = page <<2;
   ROM_ADDR_L = 0;
   if ( ROM_STATUS & bROM_ADDR_OK )
   {
      if ((uint8_t) &IAP_DeletePage & 0x01)
      {
         ROM_CTRL = ROM_CMD_ERASE;
         _nop_( );
      }
      else
      {
         _nop_( );
         ROM_CTRL = ROM_CMD_ERASE;
      }
      return((ROM_STATUS ^ bROM_ADDR_OK) & 0x7F);
   }
   else return(bROM_ADDR_OK);
}

void IAP_Exit(void)
{
   SAFE_MOD = 0x55;
   SAFE_MOD = 0xAA;
   GLOBAL_CFG |= bSW_RESET;
  while(1);
}

/* program one sector into code flash note the extra param SectorNum */
uint8_t IAP_Prom(uint8_t xdata *buffer,uint16_t len,uint8_t SectorNum)
{
//   uint16_t i;
   uint8_t  error;
   uint16_t Addr;
   uint16_t Data;
   // delete the rompage on the fly
   if ((SectorNum & 0x01)==0) IAP_DeletePage(SectorNum >>1);
   // sector to Address
   Addr = SectorNum << 9;
   // flash one sector
   //for(i=0;i<len;i+=2)
   if (len & 0x01) len++; //make sure len is equal
   while(len)
   {
   	  //original code
      //  Data = (buffer[2*i] | (uint16_t)buffer[2*i+1]<<8);
      //first optimize  
      //  Data = buffer[2*i+1];
      //  Data = Data << 8 | buffer[2*i];
      //fastest code but keil only
      LOW(Data) = *buffer++;
      HIGH(Data)= *buffer++;
      error = IAP_ProgWord( Addr,Data );
      Addr+=2;
      len -=2;
      if( error != 0x00 )break;
   }
   return error;
}

