/* contains enum functions for a memory stick 
*/
#include "..\inc\mytypes.h"
#include "..\inc\wcherror.h"   // WCH error and status codes a bit of a mess
#include "..\inc\usb\usb11.h"  // my usb11 std defines
#include "..\inc\ch559usb.h"   // some defines from WCH for USB
#include "..\inc\ch559_keil.h" // the SFRs still a mess 


extern uint8_t xdata TxBuffer[];

extern void    mDelaymS(uint16_t delay);
extern void    mDelayuS(uint16_t delay);
extern uint8_t Host_CtrlGetDeviceDescr(uint16_t Vendor,uint16_t Product);
extern uint8_t Host_CtrlSetUsbAddress(uint8_t Addr);
extern uint8_t Host_CtrlGetConfigDescr(void);
extern uint8_t Host_CtrlSetUsbConfig(uint8_t cfg);
extern uint8_t Host_CtrlTransfer(uint8_t xdata *DataBuf, uint8_t idata *RetLen);


// some globals for this lib
uint8_t DevEndpOUTAddr;  
uint8_t DevEndpINAddr;    
uint8_t CurrentLun;      

//to be compatible with WCH code
#define pSetupReq ((PUSB_SETUP_REQ)TxBuffer) 

/* class request to learn about Logical Unit Numbers (lUN)
   Sticks usually dont have these 
*/
uint8_t	Host_CtrlGetMaxLUN( void )
{
	 uint8_t	error;
	 uint8_t	idata len;
	
	 TxBuffer[0]= _HOST | _CLASS | _INTERFACE;
   TxBuffer[1]= 0xFE;
   TxBuffer[2]= 0x00;
   TxBuffer[3]= 0x00;
   TxBuffer[4]= 0x00;
   TxBuffer[5]= 0x00;
   TxBuffer[6]= 0x01; //sizeof(DeviceDescriptor);
   TxBuffer[7]= 0x00;

	 error = Host_CtrlTransfer( TxBuffer, &len );
	 if (error)     return error;
	 if ( len != 1) return ERR_USB_BUF_OVER;
	 CurrentLun = TxBuffer[0];
	 UH_RX_CTRL = UH_TX_CTRL = bUH_R_TOG | bUH_T_TOG;
	 return ERR_SUCCESS;
}


/* enumerate the memory stick  

*/
uint8_t Host_EnumMemStick(void)
{
   uint8_t error;
   // learn about the device ignore VID / PID
   error = Host_CtrlGetDeviceDescr(0x0000,0x0000);
   if (error) return error;
   //	set the USB Address
   error = Host_CtrlSetUsbAddress(0x02);
   if (error) return error;
   	   	
   error = Host_CtrlGetConfigDescr();
   if (error) return error;
   // check the fields
   if (((pConfigurationDescriptor)TxBuffer)-> wTotalLengthHi) 
   	  return ERR_USB_UNSUPPORT; 
   if (((pConfigurationDescriptor)TxBuffer)-> wTotalLengthLo != 0x32)
   	  return ERR_USB_UNSUPPORT;	
   //has to be CLASS_MSD
   if ((((PUSB_CFG_DESCR_LONG)TxBuffer)->itf_descr.bInterfaceClass) != 0x08) 
     return ERR_USB_UNSUPPORT;	
   //has to bulk only protocol
   if ((((PUSB_CFG_DESCR_LONG)TxBuffer)->itf_descr.bInterfaceProtocol) != 0x50) 
     return ERR_USB_UNSUPPORT;
   
   // save both bulk eps
   if((((PUSB_CFG_DESCR_LONG)TxBuffer) -> endp_descr[0].bEndPointAddress)>0x80)
   {
      DevEndpOUTAddr = (((PUSB_CFG_DESCR_LONG)TxBuffer)-> endp_descr[1].bEndPointAddress)&0x0f;
      DevEndpINAddr  = (((PUSB_CFG_DESCR_LONG)TxBuffer)-> endp_descr[0].bEndPointAddress)&0x0f;
   }
   else
   {
      DevEndpOUTAddr = (((PUSB_CFG_DESCR_LONG)TxBuffer)-> endp_descr[0].bEndPointAddress)&0x0f;
      DevEndpINAddr  = (((PUSB_CFG_DESCR_LONG)TxBuffer)-> endp_descr[1].bEndPointAddress)&0x0f;
   }
   
   return Host_CtrlSetUsbConfig(((pConfigurationDescriptor)TxBuffer)->bConfigurationValue);
}

