#include "..\inc\mytypes.h"
#include "..\inc\ch559_keil.h"
#include "..\inc\wcherror.h"

#include "..\inc\udisklib.h"
#include <stdio.h>
uint8_t  code Fname[12] ="CH559UUPHEX";  //8.3 upcase padded with <space>

uint8_t  xdata RxBuffer[64+4] _at_ 0x0000;
uint8_t  xdata TxBuffer[512]  _at_ 0x0044;

uint8_t  volatile xdata UH_EP_MOD   _at_ 0x2447;
uint8_t  volatile xdata UH_RX_DMA_H _at_ 0x244C;
uint8_t  volatile xdata UH_TX_DMA_H _at_ 0x244E;

#ifdef TESTCODE
// gives 57600 Baud @ 12 MHz
#define T1_RELOAD  (0-((12000000L) /16/57600))
void	InitUart0()
{
   TMOD  = (TMOD &~ MASK_T1_MOD) | bT1_M1; /*auto reload 8 bit timer*/ 
   T2MOD = T2MOD | bTMR_CLK | bT1_CLK;     /*runing at fsys */         \ 
   TH1   = T1_RELOAD;                      /* load the calculated reload value*/ \  
   TR1   = 1;                                                          \
   SCON  = 0x52;                           /* 8bit var baudrate     */\
}

#endif
void    mDelayuS(uint16_t delay)
{
	 while (delay) 
	 {
	 	  ++ SAFE_MOD;
      --delay;
	 }	
}


void mDelaymS(uint16_t delay)
{
	 while (delay) 
	 {
		  mDelayuS(1000);
		  -- delay;
	 }
}


void main( )
{
   uint8_t status;
   uint8_t i;
   EA = 0;
   ES = 0;
   PIN_FUNC &= ~bUART0_PIN_X;
   mDelaymS(30);

#ifdef TESTCODE  
   InitUart0();
#endif   
   Host_InitUSB();
   
   P4_DIR |= 1<<3;
   P4_OUT |= 1<<3;
   P4_OUT &= ~(1<<3);
   
   while (1)
   {
      if(UIF_DETECT)
      {
         UIF_DETECT = 0;
         status = AnalyzeRootHub();
         if (status == ERR_USB_CONNECT)
         {
            mDelaymS(200);
            Host_InitRootDevice();
            status = Host_EnumMemStick();
#ifdef TESTCODE           
            if (status) printf("enum failt with code 0x%bX!\n",status);
#endif
            if (status == ERR_SUCCESS)
            {           	 
               DeviceStatus = DISK_USB_ADDR;
               
               for ( i = 0; i != 10; i ++ )
               {
                  //printf( "Wait DiskReady\n" );
                  status = Host_CtrlGetMaxLUN();
                  if(status == ERR_SUCCESS) break;
               }
               
               status = UDisk_ReadDiskDBR(TxBuffer);
#ifdef TESTCODE
               if (status) printf("reading bootrecord failed with code 0x%bX!\n",status);
#endif               
               if (status) IAP_Exit();

               status = UDisk_FileOpen(TxBuffer);
               if(status) IAP_Exit();

               status = UDisk_ReadFile(TxBuffer);
               if(status) IAP_Exit();
               
               P4_OUT |= (1<<3);
                  
            }
         }
      }
   }
}
