#include "..\inc\mytypes.h"
#include "..\inc\wcherror.h"
#include "..\inc\usb\usb11.h"
#include "..\inc\ch559usb.h"
#include "..\inc\ch559_keil.h"

//#ifndef NULL
//  #define NULL ((void *) 0)
//#endif

extern uint8_t xdata RxBuffer[];
extern uint8_t xdata TxBuffer[];

//extern uint8_t AnalyzeRootHub(void);
extern void    mDelaymS(uint16_t delay);
extern void    mDelayuS(uint16_t delay);
extern uint8_t Host_EnumDevice(void);
extern uint8_t DeviceEp0Size;


bit     bNewDevice;
uint8_t DeviceStatus;

#define pSetupReq ((PUSB_SETUP_REQ)TxBuffer)
#define	WAIT_USB_TOUT_200US		200

void	ResetRootHubPort( void )
{
	 //UsbDevEndp0Size = DEFAULT_ENDP0_SIZE;  
	 USB_DEV_AD = 0;
   UHUB0_CTRL = UHUB0_CTRL & ~ bUH_LOW_SPEED | bUH_BUS_RESET;
	 mDelaymS(15);  
	 UHUB0_CTRL = UHUB0_CTRL & ~ bUH_BUS_RESET;  
	 mDelayuS(250);
	 UIF_DETECT = 0;
}

uint8_t	EnableRootHubPort(void)
{
	if ( DeviceStatus < DISK_CONNECT ) DeviceStatus = DISK_CONNECT;
	if ( USB_HUB_ST & bUHS_H0_ATTACH ) 
  {
		UHUB0_CTRL |= bUH_PORT_EN;
		return( ERR_SUCCESS );
	}
	return ERR_USB_DISCON;
}

void	DisableRootHubPort(void)
{
	 DeviceStatus = DISK_DISCONNECT;
}

// this one is strange
uint8_t	AnalyzeRootHub(void)
{
	uint8_t	status = ERR_SUCCESS;
	
  if ( USB_HUB_ST & bUHS_H0_ATTACH ) 
  {
		if (DeviceStatus == DISK_DISCONNECT || (UHUB0_CTRL & bUH_PORT_EN) == 0x00 ) 
    {
			DisableRootHubPort();
			DeviceStatus = DISK_CONNECT;
			status = ERR_USB_CONNECT;
		}
	}
	else if (DeviceStatus >= DISK_CONNECT) 
  {
		DisableRootHubPort();
		if (status == ERR_SUCCESS) status = ERR_USB_DISCON;
	}
	return status;
}


void Host_InitUSB(void) 
{
	IE_USB      = 0;					
	USB_CTRL    = bUC_HOST_MODE;
	USB_DEV_AD  = 0x00;
	
	UHUB1_CTRL &= ~bUH1_DISABLE; 
	UH_EP_MOD   = bUH_EP_TX_EN | bUH_EP_RX_EN;
	UH_RX_DMA   = RxBuffer;
	UH_TX_DMA   = TxBuffer;
	UH_RX_CTRL  = 0x00;
	UH_TX_CTRL  = 0x00;
	USB_CTRL    = bUC_HOST_MODE | bUC_INT_BUSY | bUC_DMA_EN;
	UH_SETUP    = bUH_SOF_EN;
	USB_INT_FG  = 0xFF;
	USB_INT_EN  = bUIE_TRANSFER | bUIE_DETECT;
}

uint8_t	Host_InitRootDevice(void)
{
	uint8_t	i, s;
  // dv_cls, if_cls;
	ResetRootHubPort();
	for ( i = 0, s = 0; i < 100; i ++ ) 
  {
		mDelaymS( 1 );
		if ( EnableRootHubPort( ) == ERR_SUCCESS ) 
    { 
			i = 0;
			s ++; 
			if ( s > 100 ) break;  
		}
	}
  
	if ( i ) 
  {
		DisableRootHubPort();
		return(ERR_USB_DISCON);
	}
//s = Host_EnumDevice();
/*
	s = CtrlGetDeviceDescr( );  // ȡ豸
	if ( s == ERR_SUCCESS ) 
  {		
		dv_cls = ( (PXUSB_DEV_DESCR)TxBuffer ) -> bDeviceClass;  // 豸
		s = CtrlSetUsbAddress( ( (PUSB_SETUP_REQ)SetupSetUsbAddr ) -> wValueL );  // USB豸ַ
		if ( s == ERR_SUCCESS ) {
			s = CtrlGetConfigDescr( );  // ȡ
			if ( s == ERR_SUCCESS ) 
      {
				if_cls = ( (PXUSB_CFG_DESCR_LONG)TxBuffer ) -> itf_descr.bInterfaceClass;  // ӿ
				if ( dv_cls == 0x00 && if_cls == USB_DEV_CLASS_STORAGE ) {  // USB洢豸,ȷU
					CH559DiskStatus = DISK_USB_ADDR;
					return( ERR_SUCCESS );
				}
				else return( ERR_USB_UNSUPPORT );
				
			}
		}
	}
*/
  //if (s) return s;
  //DeviceStatus = DISK_CONNECT;
	return( 0);
}

uint8_t Host_UsbTransact(uint8_t endp_pid, uint8_t tog, uint16_t timeout)
{
   uint8_t  TransRetry;
   uint8_t  status;
   uint8_t  r;
   uint16_t i;

   UH_RX_CTRL = UH_TX_CTRL = tog;
   TransRetry = 0;
   do
   {
      UH_EP_PID = endp_pid;
      //
      // wait for UIF_TRANSFER set within a short period 
      // if the bit is not set within a short time exit 
      // 
      UIF_TRANSFER = 0;      
      for (i = WAIT_USB_TOUT_200US; i != 0 && UIF_TRANSFER == 0; i --);
      UH_EP_PID = 0x00;
      if (UIF_TRANSFER == 0) return ERR_USB_UNKNOWN;      
      //
      // do pnp checks to make sure the device i still connected
      //
      if (UIF_DETECT)
      {
         UIF_DETECT = 0;
         status = AnalyzeRootHub();
         if (status == ERR_USB_CONNECT) bNewDevice = 1;
         if (DeviceStatus == DISK_DISCONNECT) return ERR_USB_DISCON;
         if (DeviceStatus == DISK_CONNECT)    return ERR_USB_CONNECT;
         //if ( ( USB_HUB_ST & bUHS_H0_ATTACH ) == 0x00 ) return( ERR_USB_DISCON );
         mDelayuS(200);
      }
      //
      // transfer events
      //
      if (UIF_TRANSFER)
      {  //do some common checks early so the swich will get simplified
         if (U_TOG_OK) return ERR_SUCCESS;
         r = USB_INT_ST & MASK_UIS_H_RES;
         if (r == USB_PID_STALL) return r | ERR_USB_TRANSFER;
         if (r == USB_PID_NAK)
         {  // handle the timeout in case there are NAKS
            if ( timeout == 0 ) return( r | ERR_USB_TRANSFER );
            if ( timeout < 0xFFFF ) timeout --;
            -- TransRetry;
         }
         else
         {  // handle the remaining events 
            switch ( endp_pid >> 4 )
            {
               case USB_PID_SETUP:
               case USB_PID_OUT:
                    if (r) return r | ERR_USB_TRANSFER;
                    break;
               case USB_PID_IN:
                    if  (r == USB_PID_DATA0 && r == USB_PID_DATA1)
                    {
                    	 ;
                    }
                    else if (r) return r | ERR_USB_TRANSFER ;
                    break;
               default:
                    return  ERR_USB_UNKNOWN;
//                  break; // break is not neccessary
            }
         }
      }
      else // ignore all other events
      {
         USB_INT_FG = 0xFF;
      }
      mDelayuS(15);
   } while (++ TransRetry < 3);
   return ERR_USB_TRANSFER;
}


